//---------------------------------------------------------------------------

#pragma hdrstop

#include <tchar.h>
//---------------------------------------------------------------------------

//
//		Y. Okamoto 2010.2
//
#include <cmath>
#include <iostream>
#include <iomanip>
#include <fstream>
#include "myLib.h"

using namespace std;
using namespace myLib;

#pragma argsused
int _tmain(int argc, _TCHAR* argv[])
{
	//
	//    ͗peLXgt@CƓ̓Xg[̐ݒ
	//
	cout << "Input data file = ";
	string fin_nm;
	cin >> fin_nm;
	RdTxtLn rd( fin_nm );
	if (rd.iCond != 0){
		cout << "To open input data file failed." << endl;
		return 9;
	}

	//
	//    o͗peLXgt@CƏo̓Xg[̐ݒ
	//
	cout << "Output file = ";
	char  fout_nm[200];
	cin >> fout_nm;
	ofstream fout( fout_nm );
	fout << "Input data file = " << fin_nm << endl << endl;

	//
	//@@@@̓t@C̐擪i"/"Ŏn܂s܂Łj̓ǂݔ΂
	//
	string s;
	int ick = 0;
	do{
		rd.readline( s );
		if (s.size() > 0)
			if (s[0] == '/') ick = 1;
	}while( ick == 0 );

	rd.readline(s);
	int r = strToInt(SeekStr(s, 0));
	int c = strToInt(SeekStr(s, 1));

	double ** O, ** E;
	O = new double*[r];
	E = new double*[r];
	for (int i = 0; i < r; i++){
		O[i] = new double[c];
		E[i] = new double[c];
	}


	 for (int i = 0; i < r; i++){
		 rd.readline(s);
		 for (int j = 0; j < c; j++)
			 O[i][j] = strToDouble(SeekStr(s, j));
	 }

	 rd.close();


	 double * R, * C;
	 R = new double[r];
	 for (int i = 0; i < r; i++){
		R[i] = 0.0;
		for (int j = 0; j < c; j++) R[i] += O[i][j];
	 }
	 C = new double[c];
	 for (int j = 0; j < c; j++){
		C[j] = 0.0;
		for (int i = 0; i < r; i++) C[j] += O[i][j];
	 }

	 int N = 0;
	 fout << endl << "Data..." << endl;
	 for (int i = 0; i < r; i++){
		 for (int j = 0; j < c; j++)
			fout << right << setw(10) << O[i][j];
		 fout << right << setw(10) << "sum(" << R[i] << ")" << endl;
		 N += R[i];
	 }


	 fout << "sum" << endl;
	 for (int j = 0; j < c; j++)
		fout << right << setw(10) << C[j];
	 fout << right << setw(10) << N << endl;

	 for (int i = 0; i < r; i++)
		 for (int j = 0; j < c; j++)
			 E[i][j] = R[i] * C[j] / N;
	 double chi2 = 0.0;
	 for (int i = 0; i < r; i++)
		 for (int j = 0; j < c; j++)
			 chi2 += sqr(O[i][j] - E[i][j]) / E[i][j];

  	 fout << endl << "Chi-squared = " << chi2 << "     df = " << (r-1)*(c-1) << endl;

	 fout.close();

	 cout << endl << fout_nm << " was saved." << endl;
	 cout << endl << "Press any char-key, then press enter-key." << endl;
	 char ck_c[100];
	 cin >> c;

	 return 0;
}
//---------------------------------------------------------------------------
